PUB start (address)
    P3_mask_value := |<3
    P4_mask_value := |<4    
    cognew(@asm_entry, address)                                 'launch assembly program into a COG

DAT
              org
asm_entry
              mov     ctra,ctra_value                   ' Set timer for unconditional count
              mov     frqa, #1                          ' Start timer

:loop         waitpeq P4_mask_value,P4_mask_value       ' Wait for TX pin to go HIGH
              mov     phsa, #0                          ' Clear counter
              waitpeq P3_mask_value,P3_mask_value       ' Wait for RX pin to go HIGH
              mov     Data, phsa                        ' Capture counter value
              wrlong  Data, par                         ' Write counter value
              waitpeq zero,P4_mask_value                ' Wait until TX pin goes LOW              
              jmp       #:loop      
                            

ctra_value    long      %0_11111_000_00000000_000000_000_000000
P3_mask_value long      0
P4_mask_value long      0
zero          long      0
Data          long      0